/*************************************************** 
  Based on an example for the Adafruit 16-channel PWM & Servo driver
  ------> http://www.adafruit.com/products/815
 ****************************************************/

#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>

Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(0x40); // 0x40 is the default I2C address

// variables for the 5 LEDs on the inner ring of the star
bool ledON = false;
int minLED = 3;
int maxLED = 7;
int countLED = minLED;

// random LEDs will be switched on or off
int randOuterLED;
int randInnerLED;
int randBrightness;
int centerIncrease = 50;
int maxBrightness = 1000;
int minBrightness =200;
int centerBrightness = minBrightness;

void setup() {
  Serial.begin(9600);
  Serial.println("16 channel PWM LED Star!");

// setting output pins for 5 inner LEDs on the star
  for (int j = minLED; j <= maxLED; j++) {
    pinMode(j,OUTPUT);
  }

  pwm.begin();
  pwm.setOscillatorFrequency(25000000);
  pwm.setPWMFreq(1600);  // This is the maximum PWM frequency

  // if you want to really speed stuff up, you can go into 'fast 400khz I2C' mode
  // some i2c devices dont like this so much so if you're sharing the bus, watch
  // out for this!
  Wire.setClock(400000);
}

void loop() {
  // set five random LEDs on the outer Ring to random brightness
  for (int i = 0; i < 5; i++) {
    randOuterLED = random(15);
    randBrightness = random(minBrightness,maxBrightness);
    pwm.setPWM(randOuterLED, 0, randBrightness);
//    Serial.println(randOuterLED);
//    Serial.println(randBrightness);
  }
  //  delay(100);
  // now switch random LEDs on the outer Ring off
  for (int i = 0; i < 5; i++) {
    randOuterLED = random(15);
    pwm.setPWM(randOuterLED, 0, 4096);
  }
  
  // center LED will increase and decrease
  pwm.setPWM(15, 0, centerBrightness);
  centerBrightness += centerIncrease;
  if (centerBrightness > maxBrightness) centerIncrease = -centerIncrease;
  if (centerBrightness < minBrightness) centerIncrease = -centerIncrease;
  
  // LEDs on the inner ring will be toggled randomly
  randInnerLED = random(minLED, maxLED +1);
  ledON = random(2);
  if (ledON) digitalWrite(randInnerLED, HIGH);
  else       digitalWrite(randInnerLED, LOW);
//  Serial.println(ledON);
//  Serial.println();
  
  // wait 100ms
  delay(100);
}
